diff --git a/dlls/user32/tests/input.c b/dlls/user32/tests/input.c
index d45edf1..b0f495a 100644
--- a/dlls/user32/tests/input.c
+++ b/dlls/user32/tests/input.c
@@ -1617,6 +2800,18 @@ START_TEST(input)
     test_get_async_key_state();
     test_keyboard_layout_name();
 
+    test_def_raw_input_proc();
+    test_get_raw_input_device_list();
+    test_get_raw_input_device_info_w();
+    test_get_raw_input_device_info_a();
+    test_basic_get_registered_raw_input_devices();
+    test_basic_register_raw_input_devices();
+    test_raw_input_device_flag_preconditions();
+    test_extended_register_raw_input_devices();
+    test_get_raw_input_data();
+    test_get_raw_input_buffer();
+    test_get_raw_input_data_simulation();
+
     if(pGetMouseMovePointsEx)
         test_GetMouseMovePointsEx();
     else
diff --git a/server/process.c b/server/process.c
index c88c89b..6b5e348 100644
--- a/server/process.c
+++ b/server/process.c
@@ -48,6 +48,7 @@
 #include "request.h"
 #include "user.h"
 #include "security.h"
+#include "raw_input.h"
 
 /* process structure */
 
@@ -333,10 +334,14 @@ struct thread *create_process( int fd, struct thread *parent_thread, int inherit
     process->desktop         = 0;
     process->token           = NULL;
     process->trace_data      = 0;
+    process->raw_input_len   = 0;
+    process->raw_input_index = 0;
     list_init( &process->thread_list );
     list_init( &process->locks );
     list_init( &process->classes );
     list_init( &process->dlls );
+    list_init( &process->raw_registered );
+    list_init( &process->raw_inputs );
 
     process->start_time = current_time;
     process->end_time = 0;
@@ -419,6 +424,7 @@ static void process_destroy( struct object *obj )
 
     close_process_handles( process );
     set_process_startup_state( process, STARTUP_ABORTED );
+    release_raw_input( &process->raw_registered, &process->raw_inputs );
     if (process->console) release_object( process->console );
     if (process->parent) release_object( process->parent );
     if (process->msg_fd) release_object( process->msg_fd );
diff --git a/server/process.h b/server/process.h
index da51a0e..d4dc9f3 100644
--- a/server/process.h
+++ b/server/process.h
@@ -22,6 +22,7 @@
 #define __WINE_SERVER_PROCESS_H
 
 #include "object.h"
+#include "raw_input.h"
 
 struct atom_table;
 struct handle_table;
@@ -81,6 +82,10 @@ struct process
     client_ptr_t         peb;             /* PEB address in client address space */
     client_ptr_t         ldt_copy;        /* pointer to LDT copy in client addr space */
     unsigned int         trace_data;      /* opaque data used by the process tracing mechanism */
+    struct list          raw_registered;  /* registered raw input devices */
+    struct list          raw_inputs;      /* queued raw inputs */
+    unsigned int         raw_input_len;   /* number of valid raw input event ids */
+    unsigned int         raw_input_index; /* number of raw input events issued */
 };
 
 struct process_snapshot
diff --git a/server/protocol.def b/server/protocol.def
index 123f16a..b94a869 100644
--- a/server/protocol.def
+++ b/server/protocol.def
@@ -3365,3 +3365,72 @@ enum coords_relative
 @REQ(set_suspend_context)
     VARARG(context,context);   /* thread context */
 @END
+
+
+/* Get the raw input device list */
+@REQ(get_raw_input_device_list)
+    unsigned int   report_size_only; /* reply only with the device count */
+@REPLY
+    unsigned int   num_devices;      /* number of raw input device in the system */
+    VARARG(devices,bytes);           /* RAWINPUTDEVICELIST structures */
+@END
+
+/* Get the raw input device info */
+@REQ(get_raw_input_device_info)
+    user_handle_t  handle;           /* raw input device handle */
+    unsigned int   command;          /* desired characteristic of the device */
+    unsigned int   report_size_only; /* reply only the with the required size to store the data */
+@REPLY
+    data_size_t    size;             /* size of the data about the device */
+    VARARG(info,bytes);              /* string or data structure about the device */
+@END
+
+/* Get the registered raw input devices */
+@REQ(get_registered_raw_input_devices)
+    unsigned int   report_size_only; /* reply only with the device count */
+@REPLY
+    unsigned int   num_devices;      /* number of raw input device registrations */
+    VARARG(devices,bytes);           /* RAWINPUTDEVICE structures */
+@END
+
+/* Register raw input devices */
+@REQ(register_raw_input_devices)
+    unsigned int   count;            /* number of registrations submitted */
+    VARARG(registrations,bytes);     /* raw_input_device_registration structures (see below) */
+@END
+struct raw_input_device_registration
+{
+    unsigned short usage_page;       /* usage page of the device group to register to */
+    unsigned short usage;            /* usage id of the device to register to */
+    unsigned int   flags;            /* configuration of the registration (see below) */
+    user_handle_t  target_window;    /* optional window handle to receive input messages */
+};
+#define RAW_INPUT_DEVICE_FLAG_REMOVE       0x0001
+#define RAW_INPUT_DEVICE_FLAG_PAGEONLY     0x0002
+#define RAW_INPUT_DEVICE_FLAG_EXCLUDE      0x0004
+#define RAW_INPUT_DEVICE_FLAG_NOLEGACY     0x0008
+#define RAW_INPUT_DEVICE_FLAG_NOHOTKEYS    0x0010
+#define RAW_INPUT_DEVICE_FLAG_CAPTUREMOUSE 0x0020
+#define RAW_INPUT_DEVICE_FLAG_APPKEYS      0x0040
+#define RAW_INPUT_DEVICE_FLAG_INPUTSINK    0x0080
+#define RAW_INPUT_DEVICE_FLAG_EXINPUTSINK  0x0100
+#define RAW_INPUT_DEVICE_FLAG_DEVNOTIFY    0x0200
+
+/* Get raw input data */
+@REQ(get_raw_input_data)
+    user_handle_t  handle;           /* raw input event handle */
+    unsigned int   command;          /* instruction to reply with just the header or the whole data */
+    unsigned int   report_size_only; /* reply only with the required size to store the data */
+@REPLY
+    data_size_t    size;             /* size of the raw input data */
+    VARARG(data,bytes);              /* RAWINPUTHEADER or RAWINPUT data structure */
+@END
+
+/* Get buffered raw input data */
+@REQ(get_raw_input_buffer)
+    unsigned int   report_size_only; /* reply only with the minimum size to get the first entry */
+@REPLY
+    unsigned int   count;            /* count of raw input events returned */
+    data_size_t    minimum_size;     /* minimum buffer size to retrieve a buffered entry */
+    VARARG(data,bytes);              /* RAWINPUT data structures */
+@END
diff --git a/server/queue.c b/server/queue.c
index 03b0e92..1db320d 100644
--- a/server/queue.c
+++ b/server/queue.c
@@ -40,6 +40,7 @@
 #include "process.h"
 #include "request.h"
 #include "user.h"
+#include "raw_input.h"
 
 #define WM_NCMOUSEFIRST WM_NCMOUSEMOVE
 #define WM_NCMOUSELAST  (WM_NCMOUSEFIRST+(WM_MOUSELAST-WM_MOUSEFIRST))
@@ -121,6 +122,7 @@ struct msg_queue
     unsigned int           changed_mask;    /* changed wakeup mask */
     int                    paint_count;     /* pending paint messages count */
     int                    hotkey_count;    /* pending hotkey messages count */
+    int                    rawinput_count;  /* pending raw input messages count */
     int                    quit_message;    /* is there a pending quit message? */
     int                    exit_code;       /* exit code of pending quit message */
     int                    cursor_count;    /* per-queue cursor show count */
@@ -281,6 +283,7 @@ static struct msg_queue *create_msg_queue( struct thread *thread, struct thread_
         queue->changed_mask    = 0;
         queue->paint_count     = 0;
         queue->hotkey_count    = 0;
+        queue->rawinput_count  = 0;
         queue->quit_message    = 0;
         queue->cursor_count    = 0;
         queue->recv_result     = NULL;
@@ -437,6 +440,12 @@ static inline int is_keyboard_msg( struct message *msg )
     return (msg->msg >= WM_KEYFIRST && msg->msg <= WM_KEYLAST);
 }
 
+/* check whether msg is a mouse message */
+static inline int is_mouse_msg( struct message *msg )
+{
+    return (msg->msg >= WM_MOUSEFIRST && msg->msg <= WM_MOUSELAST);
+}
+
 /* check if message is matched by the filter */
 static inline int check_msg_filter( unsigned int msg, unsigned int first, unsigned int last )
 {
@@ -604,6 +613,8 @@ static void remove_queue_message( struct msg_queue *queue, struct message *msg,
             clear_queue_bits( queue, QS_POSTMESSAGE|QS_ALLPOSTMESSAGE );
         if (msg->msg == WM_HOTKEY && --queue->hotkey_count == 0)
             clear_queue_bits( queue, QS_HOTKEY );
+        if (msg->msg == WM_INPUT && --queue->rawinput_count == 0)
+            clear_queue_bits( queue, QS_RAWINPUT );
         break;
     }
     free_message( msg );
@@ -1455,7 +1466,10 @@ static void queue_hardware_message( struct desktop *desktop, struct message *msg
     if (win != desktop->cursor.win) always_queue = 1;
     desktop->cursor.win = win;
 
-    if (!always_queue || merge_message( input, msg )) free_message( msg );
+    if ((is_keyboard_msg( msg ) && is_nolegacy_set_for_raw_input_keyboard()) ||
+            (is_mouse_msg( msg ) && is_nolegacy_set_for_raw_input_mouse()) ||
+            !always_queue || merge_message( input, msg ))
+        free_message( msg );
     else
     {
         msg->unique_id = 0;  /* will be set once we return it to the app */
@@ -1952,6 +1966,11 @@ void post_message( user_handle_t win, unsigned int message, lparam_t wparam, lpa
             set_queue_bits( thread->queue, QS_HOTKEY );
             thread->queue->hotkey_count++;
         }
+        if (message == WM_INPUT)
+        {
+            set_queue_bits( thread->queue, QS_RAWINPUT );
+            thread->queue->rawinput_count++;
+        }
     }
     release_object( thread );
 }
@@ -2014,6 +2033,52 @@ void free_hotkeys( struct desktop *desktop, user_handle_t window )
 }
 
 
+/* Get the count and handles of queued raw input messages */
+BOOL get_queued_raw_input_message_handles( lparam_t **handles, unsigned int *count )
+{
+    struct msg_queue *queue = get_current_queue();
+    struct message *msg;
+    unsigned int index = 0;
+
+    if (!queue->rawinput_count)
+    {
+        *handles = NULL;
+        *count = 0;
+        return TRUE;
+    }
+
+    *handles = mem_alloc( queue->rawinput_count * sizeof( lparam_t ) );
+    if (!*handles)
+        return FALSE;
+
+    *count = queue->rawinput_count;
+
+    LIST_FOR_EACH_ENTRY( msg, &queue->msg_list[POST_MESSAGE], struct message, entry )
+    {
+        if (msg->msg == WM_INPUT)
+            (*handles)[index++] = msg->lparam;
+    }
+
+    return TRUE;
+}
+
+/* Remove given amount of raw input messages */
+void dequeue_raw_input_messages( unsigned int count )
+{
+    struct msg_queue *queue = get_current_queue();
+    struct message *msg, *msg2;
+
+    LIST_FOR_EACH_ENTRY_SAFE( msg, msg2, &queue->msg_list[POST_MESSAGE], struct message, entry )
+    {
+        if (msg->msg != WM_INPUT)
+            continue;
+        if (!count--)
+            break;
+        remove_queue_message( queue, msg, POST_MESSAGE );
+    }
+}
+
+
 /* check if the thread owning the window is hung */
 DECL_HANDLER(is_window_hung)
 {
@@ -2195,9 +2260,15 @@ DECL_HANDLER(send_hardware_message)
     switch (req->input.type)
     {
     case INPUT_MOUSE:
+        queue_mouse_raw_input( req->input.mouse.flags, req->input.mouse.info,
+            req->input.mouse.data, req->input.mouse.x, req->input.mouse.y, desktop->cursor.x,
+            desktop->cursor.y, desktop->foreground_input ? desktop->foreground_input->focus : 0 );
         reply->wait = queue_mouse_message( desktop, req->win, &req->input, req->flags, sender );
         break;
     case INPUT_KEYBOARD:
+        queue_keyboard_raw_input( req->input.kbd.flags, req->input.kbd.info,
+            req->input.kbd.vkey, req->input.kbd.scan,
+            desktop->foreground_input ? desktop->foreground_input->focus : 0 );
         reply->wait = queue_keyboard_message( desktop, req->win, &req->input, req->flags, sender );
         break;
     case INPUT_HARDWARE:
